package com.selenetan.asteroids 
{
    import com.selenetan.core.STGlobal;
	import com.selenetan.core.STObject;
	import com.selenetan.core.STTicker;
	import flash.display.Sprite;
	
	/**
     * ...
     * @author Selene
     */
    public class Bullet extends STObject
    {
        private const BULLET_LIFETIME:Number = 0.6;     // Seconds the bullet lives
        
        private static var _numInstances:uint = 0;
        private var _id:uint;
        
        public var power:Number = 5;
        
        public function Bullet($x:Number = 0, $y:Number = 0) 
        {
            var s:Sprite = new Sprite();
            s.graphics.beginFill(0xFFFFFF);
            s.graphics.drawCircle(0, 0, 2);
            
            super(s, s, $x, $y);
            
            hitRadius = 2;
            
            health = BULLET_LIFETIME;
            
            _id = _numInstances;
            ++_numInstances;
        }
        
        override public function update():void 
        {
            super.update();
            
            this.hurt(STGlobal.ticker.elapsed);
            
            if (!dead) {
                trace("\nvelocity: " + velocity);
                trace("acceleration: " + acceleration);
                trace("angle: " + angle);
                trace("thrust: " + thrust);
            }
        }
        
        public function toString():String
        {
            return "[Bullet #" + _id + "]";
        }
        
        override public function kill():void 
        {
            super.kill();
        }
        
        override public function reset($x:Number = 0, $y:Number = 0, $args:Object = null):void 
        {
            super.reset($x, $y, $args);
            health = BULLET_LIFETIME;
            
            if ($args.angle != undefined && $args.speed != undefined) {
                velocity.x = $args.speed * Math.cos($args.angle * Math.PI / 180);
                velocity.y = -$args.speed * Math.sin($args.angle * Math.PI / 180);
                angle = $args.angle;
            }
            
        }
    }

}