package com.selenetan.asteroids 
{
    import com.selenetan.core.STGlobal;
    import com.selenetan.core.STGroup;
	import com.selenetan.core.STObject;
    import com.selenetan.core.STWorld;
    import flash.display.Sprite;
	
	/**
     * ...
     * @author Selene
     */
    public class Player extends STObject
    {
        private const BULLET_COOLDOWN:Number = 0.25; // in seconds
        
        private var _world:STWorld;
        private var _bulletGroup:STGroup;
        private var _bulletCooldown:Number;
        
        public function Player($bulletGroup:STGroup, $world:STWorld) 
        {
            trace("Player()");
            
            var s:Sprite = new Sprite();
            s.graphics.lineStyle(1, 0xFFFFFF, 1, true);
            s.graphics.drawCircle(0, 0, 16);
            s.graphics.moveTo(0, 0);
            s.graphics.lineTo(0, -22);
            
            super(s, s);
            
            hitRadius = 16;
            maxVelocity.x = 500;
            maxVelocity.y = 500;
            linearDrag = 0.95;
            
            _bulletGroup = $bulletGroup;
            _world = $world;
            
            //velocity.x = 10;
            //velocity.y = 10;
            
            health = 3;
        }
        
        
        override public function update():void 
        {
            super.update();
            //trace("\nPlayer.velocity.x: " + velocity.x);
            //trace("Player.x: " + this.x);
            
            // Turn
            if (STGlobal.keys.RIGHT) {
                this.angularVelocity = -200;
            }
            else if (STGlobal.keys.LEFT) {
                this.angularVelocity = 200;
            }
            else {
                this.angularVelocity = 0;
            }
            
            // Thrust
            if (STGlobal.keys.UP) {
                this.thrust = 100;
            }
            else {
                this.thrust = 0;
            }
            
            // Handle shooting
            if (_bulletCooldown > 0) {
                _bulletCooldown -= STGlobal.ticker.elapsed;
            }
            else if (STGlobal.keys.SPACE) {
                _bulletCooldown = BULLET_COOLDOWN;
                
                var b:Bullet = _bulletGroup.getFirstAvailable() as Bullet;
                if (!b) {
                    b = new Bullet(x, y);
                    _bulletGroup.addMember(b);
                    _world.add(b);
                }
                
                b.reset(x, y, {angle: angle, speed: 600});
                
            }
        }
        
        override public function hurt(damage:Number):void 
        {
            super.hurt(damage);
        }
        
        
    }

}