﻿package com.selenetan.asteroids 
{
    import com.selenetan.core.STGlobal;
    import com.selenetan.core.STGroup;
    import com.selenetan.core.STObject;
    import com.selenetan.core.STTicker;
    import com.selenetan.core.STTickerEvent;
    import com.selenetan.core.STUtil;
	import com.selenetan.core.STWorld;
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.geom.Rectangle;
    import flash.utils.getTimer;
	
	/**
     * ...
     * @author Selene
     */
    public class World extends STWorld
    {
        private var _ticker:STTicker;
        private var _player:Player;
        private var _asteroids:STGroup;
        private var _bullets:STGroup;
        
        
        public function World($container:Sprite, $viewWidth:Number, $viewHeight:Number) 
        {
            super($container, $viewWidth, $viewHeight, STWorld.WRAPPING_BOTH);
            bgColor = 0xFF000000;
            
            STGlobal.currentWorld = this;
            
            _ticker = new STTicker();
            _ticker.addEventListener(STTickerEvent.TICK, gameLoop);
            _ticker.start();
            STGlobal.ticker = _ticker;
            
            worldWidth = 600;
            worldHeight = 600;
            
            _asteroids = new STGroup();
            _bullets = new STGroup();
            
            _player = new Player(_bullets, this);
            _player.x = 300;
            _player.y = 300;
            
            this.add(_player);
            
            // Create some asteroids
            for (var i:int = 0; i < 10; ++i) {
                var a:Asteroid = new Asteroid(2);
                _asteroids.addMember(a);
                this.add(a);
            }
            
            
        }
        
        private function gameLoop(e:STTickerEvent):void
        {
            //trace("elapsed: " + e.elapsed);
            this.update();
            this.render();
        }
        
        override public function update():void
        {
            super.update();
            STUtil.checkResolveCollisions(_bullets.members, _asteroids.members, bulletHitAsteroid);
            STUtil.checkResolveCollisions([_player], _asteroids.members, playerHitAsteroid);
        }
        
        override public function render():void
        {
            super.render();
        }
        
        
        public function reset(e:Event):void
        {
            
        }
        
        
        private function playerHitAsteroid($o1:STObject, $o2:STObject):void
        {
            if ($o1 is Player && $o2 is Asteroid) {
                var p:Player = $o1 as Player;
                var a:Asteroid = $o2 as Asteroid;
                
                trace("Player hit!");
                
                p.hurt(1);
            }
        }
        
        /**
         * When a bullet hits an asteroid, the bullet and asteroid die.
         * If the asteroid is large, two smaller ones spawn in its place
         * @param	$o1
         * @param	$o2
         */
        private function bulletHitAsteroid($o1:STObject, $o2:STObject):void
        {
            if ($o1 is Bullet && $o2 is Asteroid) {
                trace("Bullet hit!");
                var b:Bullet = Bullet($o1);
                var a:Asteroid = Asteroid($o2);
                
                b.kill();
                a.kill();
                
                if (a.size > 0) {
                    var newAsteroids:Array = [];
                    var newSize:int = a.size - 1;
                    var numToSpawn:int = 2;         // Maybe make this a member variable and a setting
                    
                    for (var i:int = 0; i < numToSpawn; ++i) {
                        var newA:Asteroid = _asteroids.getFirstAvailable() as Asteroid;
                        if (newA == null) {
                            newA = new Asteroid(newSize);
                            _asteroids.addMember(newA);
                            add(newA);
                        }
                        
                        newA.reset(a.x, a.y, { size: newSize } );
                    }
                }
                
                
            }
        }
    }

}