﻿package com.selenetan.core 
{
	/**
     * A utility class that groups STObjects. Best used for partitioning groups for collisions,
     * or making object pools.
     * @author Selene
     */
    public class STGroup
    {
        public var members:Array;
        
        /**
         * A utility class that groups STObjects. Best used for partitioning groups for collisions,
         * or making an object pool for object reuse.
         */
        public function STGroup() 
        {
            members = [];
        }
        
        /**
         * Adds an object to the group. Currently doesn't check if it's already there.
         * @param	object
         */
        public function addMember(object:STObject):void
        {
            members.push(object);
        }
        
        
        /**
         * Gets the first available STObject (i.e. one where exists = false)
         * @return  A STObject if one is available, or a null if none is.
         */
        public function getFirstAvailable():Object
        {
            var numMembers:int = members.length;
            var obj:Object = null;
            for (var i:int = 0; i < numMembers; ++i) {
                if (!members[i].exists) {
                    obj = members[i];
                    break;
                }
            }
            
            return obj;
        }
        
    }

}