﻿package com.selenetan.core 
{
    import flash.display.Stage;
    import flash.events.KeyboardEvent;
    
    
	/**
     * ...
     * @author Selene
     */
    public class STKeys
    {
        
        public var LEFT:Boolean = false;
        public var RIGHT:Boolean = false;
        public var UP:Boolean = false;
        public var DOWN:Boolean = false;
        public var SPACE:Boolean = false;
        
        protected var _stage:Stage;
        protected var _map:Array;
        
        public function STKeys() 
        {
            _map = [];
			addKey("UP",38);
			addKey("DOWN",40);
			addKey("LEFT",37);
			addKey("RIGHT", 39);
            addKey("SPACE", 32);
        }
        
        
        /**
         * Start processing keyboard input
         */
        public function startProcessing($stage:Stage):void
        {
            _stage = $stage;
            
            _stage.addEventListener(KeyboardEvent.KEY_DOWN, processKeyDown, false);
            _stage.addEventListener(KeyboardEvent.KEY_UP, processKeyUp, false);
        }
        
        /**
         * Stop processing keyboard input
         */
        public function stopProcessing():void
        {
            _stage.removeEventListener(KeyboardEvent.KEY_DOWN, processKeyDown);
            _stage.removeEventListener(KeyboardEvent.KEY_UP, processKeyUp);
        }
        
        protected function processKeyDown(event:KeyboardEvent):void
        {
            var key:Object = _map[event.keyCode];
            if (key) {
                this[key.name] = true;
                key.pressed = true;
            }
        }
        
        protected function processKeyUp(event:KeyboardEvent):void
        {
            var key:Object = _map[event.keyCode];
            if (key) {
                this[key.name] = false;
                key.pressed = false;
            }
        }
        
        protected function addKey($name:String, $keyCode:uint):void
        {
            _map[$keyCode] = { name: $name, pressed: false };
        }
        
    }

}